lv.substitute_separators(true)
lv.setyieldingdefaults(2,0)

-- Register a selection of public LuaVIEW functions.
if app_kind()=="Development System" then
    register.public_dir(toolkit_path("luaview","functions"))
    register.public_dir(toolkit_path("clientsrv","functions"))
    register.public_dir(toolkit_path("datalog","functions"))
    register.public_dir(bootstrap_path().._SEP.."functions")
end

-- The default bootmode, used when not persisted.
mode="test"

-- When the bootmode is persisted, read it from its persistence file.
modefile=io.open(bootstrap_path().._SEP.."bootmode.txt","r")
if (modefile) then
    mode=modefile:read("*a")
    modefile:close()
end

-- Configure LuaVIEW. These settings map to the LabVIEW globals
-- contained in luaview/glb_LuaVIEW Configuration Globals.vi and
-- library/glb_Library Configuration Globals.vi.
-- See their descriptions for details. When a setting is commented out
-- or omitted, its current/default value will be used.
configure({
["bootmode"]=mode,
["resource base path"]=bootstrap_path(),
["time format"]="%Y/%m/%d %H:%M:%S%2u",
["auto-init registry"]=(app_kind()~="Development System"),
["unload functions ASAP"]=(app_kind()~="Development System"),
["script search directories"]={"","import"},
["custom info"]=[[
ESTEC, New Distributed Test Facility.
(C) 2002-2005 CIT Engineering.
LuaVIEW license #1
Developed by Albert-Jan Brouwer and Roland van Zanten.

]],
["export timeout"]=1000,
["incite timeout"]=2000,
["task error logger"]="errors",
})

-- Now we can start a script that can assume a proper configuration
-- and registered functions.
do_script("access.lua")
